/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "flop.h"

pokeraction_t actionFlop() {
  return (pokeraction_t){
    .init = &actionFlopInit,
    .update = &actionFlopUpdate,
    .dispose = &actionFlopDispose
  };
}

void actionFlopInit(int32_t index, void *data) {
  uint8_t i, count;
  logText("Flop");
  
  // Look at the dealer
  holdemRenderLookHand(&POKER_STATE.cameraLeft, HOLDEM_GAME_SEAT_DEALER);

  // Do the flop
  // if(match->cardsFacing >= HOLDEM_DEALER_HAND) return;

  // Burn the card off the top
  POKER_STATE.deckSize -= 1;

  // Change count depending on facing
  count = POKER_STATE.cardsFacing == 0 ? 0x03 : 0x01;

  // Deal
  for(i = 0; i < count; i++) {
    cardDeal(POKER_STATE.deck, POKER_STATE.cards, POKER_STATE.deckSize, POKER_STATE.cardsFacing);
    POKER_STATE.deckSize -= 1;
    POKER_STATE.cardsFacing += 1;
  }

  // Next action
  holdemActionRemove(index);
}

void actionFlopUpdate(int32_t index, void *data) {

}

void actionFlopDispose(int32_t index, void *data) {
  holdemActionAdd(actionAi());
}